function E = wentropy(data,weights,nbin)

  

% calculate histogram counts
[p,C] = hist(data(:),nbin);
C(p==0) = [];
p(p==0) = [];

W = cell(length(C),1);
for i=1:length(data(:))
    classe(i) = knnclassify(data(i),C',[1:length(C)]',1);
    W{classe(i)}=[W{classe(i)}, weights(i)];
end

% remove zero entries in p 


for i=1:length(C)
    class_weights(i)=sum(W{classe(i)});
end

% normalize p so that sum(p) is one.
p = p ./ sum(p(:));
class_weights = class_weights./sum(class_weights(:));

E = -sum(class_weights.*p.*log2(p));
  
